﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using HeuristicLab.Encodings.PermutationEncoding;
namespace HeuristicLab.Analysis.AlgorithmBehavior.Analyzers {
  public class UnwantedMutationAnalyzer {
    public static double AnalyzeUnwantedMutationsForPermutationEncoding(Permutation parent1, Permutation parent2, Permutation child) {
      int cnt = 0;
      int[] edgesP1 = CalculateEdgesVector(parent1);
      int[] edgesP2 = CalculateEdgesVector(parent2);
      int[] edgesC = CalculateEdgesVector(child);

      for (int i = 0; i < edgesP1.Length; i++) {
        if (edgesC[i] != edgesP1[i] &&
            edgesC[i] != edgesP2[i] &&
            edgesP1[edgesC[i]] != i &&
            edgesP2[edgesC[i]] != i) {
          cnt += 1;
        }
      }

      return ((double)cnt) / parent1.Length;
    }

    //copied from PermutationEqualityComparer
    private static int[] CalculateEdgesVector(Permutation permutation) {
      // transform path representation into adjacency representation
      int[] edgesVector = new int[permutation.Length];
      for (int i = 0; i < permutation.Length - 1; i++)
        edgesVector[permutation[i]] = permutation[i + 1];
      edgesVector[permutation[permutation.Length - 1]] = permutation[0];
      return edgesVector;
    }
  }
}
